"""Custom exception for every hardware related stuff."""


class DepletedStackError(Exception):
    """Raised when attempting to pop an element on an deplected stack."""

    def __init__(self, message: str):
        """Init the exception."""
        super().__init__(message)


class InvalidReadPositionError(Exception):
    """Raised when attempting to read an invalid position of the memory."""

    def __init__(self, message: str):
        """Init the exception."""
        super().__init__(message)


class InvalidWritePositionError(Exception):
    """Raised when attempting to write at an invalid position of the memory."""

    def __init__(self, message: str):
        """Init the exception."""
        super().__init__(message)


class InvalidWriteValueError(Exception):
    """Raised when attempting to write an invalid value in memory."""

    def __init__(self, message: str):
        """Init the exception."""
        super().__init__(message)
