"""File containing the custom exceptions related to an instruction."""


class InstructionInitializationError(Exception):
    """Raised by the constructor when an instruction failed to initialize."""

    pass


class UnimplementedInstructionError(Exception):
    """Raised when attempting to init. a disabled instruction."""

    def __init__(self, message: str, tag):
        """Init the exception and specify the location of the instruction."""
        super().__init__(message)
        self.tag = tag
