"""Constants used for testing bitcoin language implementation."""
from collections import namedtuple

# From script.cpp in
# https://github.com/bitcoin/bitcoin/blob/master/src/script/script.cpp
VALID_INTEGERS = [
    0,
    # skip all push_data opcodes
    *list(range(0x4F, 0xBB)),
    0xFF,
]

Token = namedtuple("Token", "name is_branching")
VALID_TOKENS = [
    Token("OP_FALSE", False),
    Token("OP_1NEGATE", False),
    Token("OP_RESERVED", False),
    Token("OP_1", False),
    Token("OP_2", False),
    Token("OP_3", False),
    Token("OP_4", False),
    Token("OP_5", False),
    Token("OP_6", False),
    Token("OP_7", False),
    Token("OP_8", False),
    Token("OP_9", False),
    Token("OP_10", False),
    Token("OP_11", False),
    Token("OP_12", False),
    Token("OP_13", False),
    Token("OP_14", False),
    Token("OP_15", False),
    Token("OP_16", False),
    Token("OP_NOP", False),
    Token("OP_VER", False),
    Token("OP_IF", True),
    Token("OP_VERIF", False),
    Token("OP_VERNOTIF", False),
    Token("OP_ELSE", True),
    Token("OP_ENDIF", True),
    Token("OP_VERIFY", True),
    Token("OP_RETURN", True),
    Token("OP_TOALTSTACK", False),
    Token("OP_FROMALTSTACK", False),
    Token("OP_2DROP", False),
    Token("OP_2DUP", False),
    Token("OP_3DUP", False),
    Token("OP_2OVER", False),
    Token("OP_2ROT", False),
    Token("OP_2SWAP", False),
    Token("OP_DEPTH", False),
    Token("OP_DROP", False),
    Token("OP_DUP", False),
    Token("OP_NIP", False),
    Token("OP_OVER", False),
    Token("OP_PICK", False),
    Token("OP_ROLL", False),
    Token("OP_ROT", False),
    Token("OP_SWAP", False),
    Token("OP_TUCK", False),
    Token("OP_CAT", False),
    Token("OP_SUBSTR", False),
    Token("OP_LEFT", False),
    Token("OP_RIGHT", False),
    Token("OP_SIZE", False),
    Token("OP_INVERT", False),
    Token("OP_AND", False),
    Token("OP_OR", False),
    Token("OP_XOR", False),
    Token("OP_EQUAL", False),
    Token("OP_RESERVED1", False),
    Token("OP_RESERVED2", False),
    Token("OP_1ADD", False),
    Token("OP_1SUB", False),
    Token("OP_2MUL", False),
    Token("OP_2DIV", False),
    Token("OP_NEGATE", False),
    Token("OP_ABS", False),
    Token("OP_NOT", False),
    Token("OP_ADD", False),
    Token("OP_SUB", False),
    Token("OP_MUL", False),
    Token("OP_DIV", False),
    Token("OP_MOD", False),
    Token("OP_LSHIFT", False),
    Token("OP_RSHIFT", False),
    Token("OP_BOOLAND", False),
    Token("OP_BOOLOR", False),
    Token("OP_NUMEQUAL", False),
    Token("OP_LESSTHAN", False),
    Token("OP_GREATERTHAN", False),
    Token("OP_LESSTHANOREQUAL", False),
    Token("OP_GREATERTHANOREQUAL", False),
    Token("OP_MIN", False),
    Token("OP_MAX", False),
    Token("OP_WITHIN", False),
    Token("OP_RIPEMD160", False),
    Token("OP_SHA1", False),
    Token("OP_SHA256", False),
    Token("OP_CODESEPARATOR", False),
    Token("OP_CHECKSIG", False),
    Token("OP_CHECKMULTISIG", False),
    Token("OP_NOP1", False),
    Token("OP_CHECKLOCKTIME", False),
    Token("OP_CHECKSEQUENCE", False),
    Token("OP_NOP4", False),
    Token("OP_NOP5", False),
    Token("OP_NOP6", False),
    Token("OP_NOP7", False),
    Token("OP_NOP8", False),
    Token("OP_NOP9", False),
    Token("OP_NOP10", False),
    Token("OP_CHECKSIGADD", False),
    Token("OP_INVALIDOPCODE", False),
    Token("OP_JUMP", True),
]
